package temperature;

import java.awt.*;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;
import java.applet.*;


public class Temperature extends Applet implements AdjustmentListener {

protected Image graph, graph_spect;
protected Graphics g, g_spect;
protected GraphCanvas graphC, graphC_spect;
protected Scrollbar typeSpec;
protected Label textInfo;
protected double TemperEtoile = 6000; 
protected double FactCorrect = 1.61; // facteur correctif pour s'approcher de 0.7UA-1.5UA en ZH du soleil (no comment...)
protected Image spec1 = Toolkit.getDefaultToolkit().getImage(Temperature.class.getResource("spect1.gif"));
protected Image spec2 = Toolkit.getDefaultToolkit().getImage(Temperature.class.getResource("spect2.gif"));
protected Image spec3 = Toolkit.getDefaultToolkit().getImage(Temperature.class.getResource("spect3.gif"));
protected Image spec4 = Toolkit.getDefaultToolkit().getImage(Temperature.class.getResource("spect4.gif"));
protected Image spec5 = Toolkit.getDefaultToolkit().getImage(Temperature.class.getResource("spect5.gif"));
protected Image spec_bg = Toolkit.getDefaultToolkit().getImage(Temperature.class.getResource("spect_bg.gif"));
protected Image soleil = Toolkit.getDefaultToolkit().getImage(Temperature.class.getResource("soleil.gif"));


public void init() 
{
     setFont(new Font(getFont().getName(), 1, 11));
	 setBackground(new Color(123, 125, 173));
	 chargementImages();
     graphC = new GraphCanvas(290, 210);
     graph = createImage(290, 210);
     g = graph.getGraphics();
     graphC_spect = new GraphCanvas(290, 35);
     graph_spect = createImage(290, 35);
     g_spect = graph_spect.getGraphics();
     Panel graphPanel = new Panel(new BorderLayout());
     Panel textPanel = new Panel(new GridLayout(2, 1));
     textInfo = new Label(Messages.get("modifiez") + " :");
     textInfo.setAlignment(1);
     textInfo.setForeground(Color.white);
     typeSpec = new Scrollbar(Scrollbar.HORIZONTAL, 0, 2, 0, 38);
     typeSpec.addAdjustmentListener(this);
     typeSpec.setValue(4);
     textPanel.add(textInfo);
     textPanel.add(typeSpec);
     graphPanel.add(graphC, BorderLayout.NORTH);
     graphPanel.add(textPanel, BorderLayout.CENTER);
     graphPanel.add(graphC_spect, BorderLayout.SOUTH);
     add(graphPanel);
     majGraph();
     validate();
}


protected void chargementImages()
{
	 MediaTracker tracker = new MediaTracker(this);
     tracker.addImage(spec1, 0);
     tracker.addImage(spec2, 1);
     tracker.addImage(spec3, 2);
     tracker.addImage(spec4, 3);
     tracker.addImage(spec5, 4);
     tracker.addImage(spec_bg, 5);
     tracker.addImage(soleil, 6);
     try {
         tracker.waitForAll();
     } catch (InterruptedException ex) {
         System.err.println("InterruptedException: " + ex.getMessage());
     }
}

 
public void adjustmentValueChanged(AdjustmentEvent adjustmentevent)
{
     java.awt.Adjustable adjustable = adjustmentevent.getAdjustable();
     if(adjustable == typeSpec)
     {
     	TemperEtoile = (double)(4000 + (adjustmentevent.getValue())*500.0);  
        majGraph();
     }
}


protected void majGraph()
{
     FontMetrics fm11 = getFontMetrics(new Font(getFont().getName(), 1, 11));
     FontMetrics fm10 = getFontMetrics(new Font(getFont().getName(), 1, 10));  
	
     // graph type spectral 
     g_spect.drawImage(spec_bg, 0 , 0, this);
     if (TemperEtoile>=4000 && TemperEtoile<=4500) g_spect.drawImage(spec1, 0 , 0, this);
     else if (TemperEtoile>=5000 && TemperEtoile<=6000) g_spect.drawImage(spec2, 0 , 0, this);
          else if (TemperEtoile>=6500 && TemperEtoile<=7000) g_spect.drawImage(spec3, 0 , 0, this);
               else if (TemperEtoile>=7500 && TemperEtoile<10000) g_spect.drawImage(spec4, 0 , 0, this);
                    else g_spect.drawImage(spec5, 0 , 0, this);
     g_spect.setColor(Color.black);     
     g_spect.setFont(new Font(getFont().getName(), 0, 9));
     g_spect.drawString(Messages.get("type_spectral_1"), 222 , 17);     
     g_spect.drawString(Messages.get("type_spectral_2"), 222 , 28);     

     // graph principal
     g.setColor(new Color(229,229,236));
     g.fillRect(0, 0, 290, 210);
     g.setColor(new Color(199,199,219));
     g.fillRect(1, 195, 289, 209);
     // composants noir
     g.setColor(Color.black);     
     g.drawLine(0, 195, 290, 195);
     g.setFont(new Font(getFont().getName(), 0, 10));
     g.drawString(Messages.get("temperature_fonction_distance"), 17 , 206);     
     g.setFont(new Font(getFont().getName(), 1, 11));
     g.drawString(Messages.get("pour_une_etoile") + " ", 63 , 15);
     g.drawString(Messages.get("de") + " " + (int)TemperEtoile + " " + Messages.get("limites"), 63 , 30);
     g.drawString(Messages.get("limites_2"), 63 , 45);
     // affichage du soleil a proximite de 5800 K
     if (TemperEtoile>=5500 && TemperEtoile<=6000) {
     	g.drawImage(soleil, 70 , 92, this);
     	g.drawString(Messages.get("temperature_soleil") + " ", 102 , 110);
     	g.drawString(Messages.get("5800_K"), 112 , 123);
     	//g.drawLine(102, 109, 106, 109);
     }       
     // composants gris
     g.setColor(new Color(150,150,150));
     g.drawLine(40, 7, 40, 175);
     g.drawLine(40, 175, 280, 175);
     g.drawLine(40, 7, 38, 11);
     g.drawLine(40, 7, 42, 11);
     g.drawLine(280, 175, 276, 173);
     g.drawLine(280, 175, 276, 177);
     g.drawString("600" , 15, 119);
     g.drawLine(38, 115, 40, 115);
     g.drawString("1200" , 10, 59); 
     g.drawLine(38, 55, 40, 55);
     g.drawString(Messages.get("abrev_distance") , 263, 170);
     g.drawString(Messages.get("T_K") , 4, 13);
     //138 = 175 - ((Tet * (1/(50(x-40))1/2))/10)
     int xDmin = (int)((Math.pow((Math.pow(FactCorrect,0.5))*TemperEtoile,2)+273800000.0)/6845000.0);
     int xDmax = (int)((Math.pow((Math.pow(FactCorrect,0.5))*TemperEtoile,2)+145800000.0)/3645000.0);
     // labels abscisse
     if (xDmax<230) g.drawString(Messages.get("parentheses_UA") , 262, 189);
     if (xDmin>110) {
     	g.drawString("2", 58, 188);
     	g.drawLine(60, 175 , 60, 177 );
     }
     if (xDmin>130) {
     	g.drawString("4", 78, 188);
     	g.drawLine(80, 175 , 80, 177 );
     }
     if (xDmin>150) {
     	g.drawString("6", 98, 188);
     	g.drawLine(100, 175 , 100, 177 );
     }     
     if (xDmax<180) {
     	g.drawString("20", 235, 188);
     	g.drawLine(240, 175 , 240, 177 );
     }
     if (xDmax<130) {
     	g.drawString("15", 185, 188);
     	g.drawLine(190, 175 , 190, 177 );
     }
     if (xDmax<80) {
     	g.drawString("10", 135, 188);
     	g.drawLine(140, 175 , 140, 177 );
     }     
     // composants bleu-gris : correspondance 0-100 -> Dmin-Dmax 
     g.setColor(new Color(195,195,210));
     g.drawLine(40, 138, xDmin, 138);
     g.drawLine(xDmin, 138, xDmin, 175);
     g.drawLine(40, 148, xDmax, 148);
     g.drawLine(xDmax, 148, xDmax, 175);
     if (xDmin>=48) {
     	g.drawLine(xDmin, 175, xDmin-2, 170);
     	g.drawLine(xDmin, 175, xDmin+2, 170);
     	g.drawLine(xDmax, 175, xDmax-2, 170);
     	g.drawLine(xDmax, 175, xDmax+2, 170);     	
     }
     // composants bleu
     g.setColor(new Color(0,0,255));
     g.drawString("100\260 C" , 2, 142);
     g.drawString("0\260 C" , 14, 153);     
     g.drawLine(40, 138, 40, 148);
     // composants rouge
     g.setColor(new Color(255,0,0));
     g.drawLine(xDmin , 175, xDmax, 175);
     g.drawLine(xDmin , 176, xDmax, 176);
     String str1 = Messages.get("entre") + " " + ((xDmin-40.0)/10.0) + " " + Messages.get("UA") + " (D";
     int decalstr1 = fm11.stringWidth(str1);
     String str2 = Messages.get("min");
     int decalstr2 = fm10.stringWidth(str2);
     String str3 = ") " + Messages.get("et") + " " + ((xDmax-40.0)/10.0) + " " + Messages.get("UA") + " (D";
     int decalstr3 = fm11.stringWidth(str3);
     String str4 = Messages.get("max");
     int decalstr4 = fm10.stringWidth(str4);
     String str5 = ")";
     int decalstr5 = fm11.stringWidth(str5);
     g.setFont(new Font(getFont().getName(), 1, 10));
     g.drawString(str2 , 63 + decalstr1 , 62);
     g.drawString(str4 , 63 + decalstr1 + decalstr2 + decalstr3 , 62);
     g.setFont(new Font(getFont().getName(), 1, 11));
     g.drawString(str1 , 63 , 60);     
     g.drawString(str3 , 63 + decalstr1 + decalstr2 , 60);  
     g.drawString(str5 , 63 + decalstr1 + decalstr2 + decalstr3 + decalstr4 , 60);
     g.drawString(Messages.get("de_etoile"), 63 , 75);
     int decalD1 = fm11.stringWidth("D");
     int decalD2 = fm10.stringWidth(Messages.get("min"));
     g.drawString("D", xDmin - decalD1 - decalD2 , 188);
     g.drawString("D", xDmax , 188);
     g.setFont(new Font(getFont().getName(), 1, 10));
     g.drawString(Messages.get("min"), xDmin - decalD2 , 190);
     g.drawString(Messages.get("max"), xDmax + decalD1 , 190);
     g.setFont(new Font(getFont().getName(), 1, 11));
     // courbe
     g.setColor(Color.black);
     int x = 40;
     int y = 0;
     for (int i=1; i<=217; i++) {
         double tmp = TemperEtoile * Math.pow((FactCorrect/(50.0*i)),0.5);
     	 g.drawLine(x, y, 40+i, 175 - (int)((tmp/10)));
         x = 40 + i;
         y = 175 - (int)((tmp/10));
     }
     
     graphC.updateImage(graph);
     graphC_spect.updateImage(graph_spect);
}


public void destroy() 
{  
	g.dispose();
	g_spect.dispose();
}

}